//
//  FullscreenImageAppDelegate.m
//  FullscreenImage
//
//  Created by Matt Gallagher on 2009/08/14.
//  Copyright 2009 Matt Gallagher. All rights reserved.
//
//  Permission is given to use this source code file, free of charge, in any
//  project, commercial or otherwise, entirely at your risk, with the condition
//  that any redistribution (in part or whole) of source code must retain
//  this copyright and permission notice. Attribution in compiled projects is
//  appreciated but not required.
//

#import "FullscreenImageAppDelegate.h"
#import "FullscreenWindow.h"

@implementation FullscreenImageAppDelegate

- (IBAction)toggleFullscreen:(id)sender
{
	if (fullscreenWindow)
	{
		NSView *firstResponder = (NSView *)[fullscreenWindow firstResponder];
		if ([firstResponder isKindOfClass:[NSTextView class]] &&
			[[(NSTextView *)firstResponder delegate] isKindOfClass:[NSTextField class]])
		{
			firstResponder = [(NSTextView *)firstResponder delegate];
		}
		else if (![firstResponder isKindOfClass:[NSView class]])
		{
			firstResponder = nil;
		}

		NSRect newFrame = [fullscreenWindow frameRectForContentRect:
			[mainWindow contentRectForFrameRect:[mainWindow frame]]];
		[fullscreenWindow
			setFrame:newFrame
			display:YES
			animate:YES];

		NSView *contentView = [[[fullscreenWindow contentView] retain] autorelease];
		[fullscreenWindow setContentView:[[[NSView alloc] init] autorelease]];

		[mainWindow setContentView:contentView];
		if (firstResponder)
		{
			[mainWindow makeFirstResponder:firstResponder];
		}
		[mainWindow makeKeyAndOrderFront:nil];

		[fullscreenWindow close];
		fullscreenWindow = nil;

		if ([[mainWindow screen] isEqual:[[NSScreen screens] objectAtIndex:0]])
		{
			[NSMenu setMenuBarVisible:YES];
		}
	}
	else
	{
		NSView *firstResponder = (NSView *)[mainWindow firstResponder];
		if ([firstResponder isKindOfClass:[NSTextView class]] &&
			[[(NSTextView *)firstResponder delegate] isKindOfClass:[NSTextField class]])
		{
			firstResponder = [(NSTextView *)firstResponder delegate];
		}
		else if (![firstResponder isKindOfClass:[NSView class]])
		{
			firstResponder = nil;
		}

		if ([[mainWindow screen] isEqual:[[NSScreen screens] objectAtIndex:0]])
		{
			[NSMenu setMenuBarVisible:NO];
		}
		
		[mainWindow orderOut:nil];

		fullscreenWindow = [[FullscreenWindow alloc]
			initWithContentRect:[mainWindow contentRectForFrameRect:[mainWindow frame]]
			styleMask:NSBorderlessWindowMask
			backing:NSBackingStoreBuffered
			defer:YES
			screen:[mainWindow screen]];
		
		NSView *contentView = [[[mainWindow contentView] retain] autorelease];
		[mainWindow setContentView:[[[NSView alloc] init] autorelease]];
		
		[fullscreenWindow setHidesOnDeactivate:YES];
		[fullscreenWindow setLevel:NSFloatingWindowLevel];
		[fullscreenWindow setContentView:contentView];
		[fullscreenWindow setTitle:[mainWindow title]];
		if (firstResponder)
		{
			[fullscreenWindow makeFirstResponder:firstResponder];
		}
		[fullscreenWindow makeKeyAndOrderFront:nil];
		
		[fullscreenWindow
			setFrame:
				[fullscreenWindow
					frameRectForContentRect:[[fullscreenWindow screen] frame]]
			display:YES
			animate:YES];
	}
}

@end
